<!DOCTYPE html>
<html lang='en'>
<head>
  <meta charset='UTF-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1.0'>
  <title>Yuhu - OH</title>

  <style>
    div {
      display: flex;
      justify-content: space-around;
      padding: 20px 0;
      border-bottom: 1px solid #ccc;
    }

    input {
      margin: 2px 0;
    }
  </style>
</head>
<body>
  <small>Version: {{ version }}</small>
  <div>
    <section>
      <h2> Controls </h2>
      <p><b>Access Token</b> 👉 <span id="access-token"><span> </p>
      <p><b>Refresh Token</b> 👉 <span id="refresh-token"><span> </p>
      <form id="refresh-token-form">
        <button type="submit"> Actualizar el refresh token </button>
      </form>
      <form id="delete-tokens-form">
        <button type="submit"> Eliminar tokens </button>
      </form>
    </section>
    <section>
      <h2> Login </h2>
      <form id='login-form'>
        <input id='username-field-login-form' type='text' name='username' placeholder='Username'> <br>
        <input id='password-field-login-form' type='password' name='password' placeholder='Password'> <br>
        <button type='submit'> Login </button>
      </form>
    </section>
    <section>
      <h2> Crear usuario </h2>
      <form id='signup-form'>
        <input id='username-field-signup-form' type='text' name='username' placeholder='Username'> <br>
        <input id='email-field-signup-form' type='email' name='email' placeholder='Email'> <br>
        <input id='password-field-signup-form' type='password' name='password' placeholder='Password'> <br>
        <button type='submit'> Crear </button>
      </form>
    </section>
  </div>
  <div>
    <section>
      <h2> Crear tarea </h2>
      mock:date-expiration > 2024-04-26T15:00:00-06:00
      <form id='create-task-form'>
        <input id='title-field' type='text' name='title' placeholder='Title'> <br>
        <input id='email-field' type='email' name='email' placeholder='Email'> <br>
        <input id='description-field' type='text' name='description' placeholder='Description'> <br>
        <input id='date-expiration-field' type='datetime' name='date_expiration' placeholder='Date expiration'> <br>
        <button type='submit'> Crear </button>
      </form>
    </section>
    <section>
      <h2> Actualizar tarea (!Auth) </h2>
      <form id='update-task-form'>
        <input id='id-field-update-task-form' type='text' name='id' placeholder='Id'> <br>
        <input id='title-field-update-task-form' type='text' name='title' placeholder='Title'> <br>
        <input id='description-field-update-task-form' type='text' name='description' placeholder='Description'> <br>
        <button type='submit'> Actualizar </button>
      </form>
    </section>
    <section>
      <h2> Eliminar tarea (!Auth) </h2>
      <form id='delete-task-form'>
        <input id='id-field-delete-task-form' type='text' name='id' placeholder='Id'> <br>
        <button type='submit'> Eliminar </button>
      </form>
    </section>
  </div>
  <div>
    <section>
      <h2> All tasks </h2>
      <form id="pagination-form">
        <input id="page-field-pagination-form" type="number" name="page" placeholder="Page">
        <input id="page-size-field-pagination-form" type="number" name="page-size" placeholder="Page size">
        <button type="submit">Ir</button>
      </form>
      <section id="summary-pagination"></section>
      <ul>
        <li>
          id >
          titulo >
          email >
          user >
          descripcion >
          fecha expiracion
        </li>
        {% for task in tasks %}
            <li>
              {{ task.id }} >
              {{ task.title }} >
              {{ task.email }} >
              {{ task.user }} >
              {{ task.description }} >
              {{ task.date_expiration }}
            </li>
        {% endfor %}
      </ul>
    </section>
    <section>
      <h2> My tasks </h2>
      <ul id="my-tasks" >
        <li> No hay tareas o no tienes una sesión.</li>
      </ul>
    </section>
  </div>

  <script>
    // obtener los tokens de localStorage
    const accessToken = localStorage.getItem('accessToken')
    const refreshToken = localStorage.getItem('refreshToken')

    // truncar los tokens a los ultimos los 10 caracteres
    const truncatedAccessToken = accessToken ? `...${accessToken.slice(-10)}` : ''
    const truncatedRefreshToken = refreshToken ? `...${refreshToken.slice(-10)}` : ''

    // mostrar los tokens en la interfaz
    document.getElementById('access-token').textContent = truncatedAccessToken
    document.getElementById('refresh-token').textContent = truncatedRefreshToken

    // form create new task
    document.getElementById('create-task-form').addEventListener('submit', function(event) {
      event.preventDefault()

      const title = document.getElementById('title-field').value
      const email = document.getElementById('email-field').value
      const description = document.getElementById('description-field').value
      const date_expiration = document.getElementById('date-expiration-field').value

      // construir el objeto de datos a enviar
      const data = {
        title,
        email,
        description,
        date_expiration
      }

      // remover las propiedades que sean string vacios
      for (const key in data) {
        if (data[key] === '') {
          delete data[key]
        }
      }

      const accessToken = localStorage.getItem('accessToken')
      let url = '/api/v1/tasks/'
      let headers = {'Content-Type': 'application/json'}
      if (accessToken) {
        url = '/api/v1/tasks/users/my/'
        headers = {
          'Content-Type': 'application/json',
          'Authorization': `Bearer ${accessToken}`
        }
        delete data.email
      }

      // realizar la solicitud POST
      fetch(url, {
        method: 'POST',
        headers,
        body: JSON.stringify(data)
      })
      .then(response => {
        if (response.ok) {
          alert('Tarea creada exitosamente!')
          location.reload()
        } else {
          alert('Ocurrió un error al crear la tarea.')
          return response.json()
        }
      })
      .then(data => {
        console.log(data)
      })
      .catch(error => {
        console.error('Error al enviar la solicitud:', error)
      })
    })

    // form login
    document.getElementById('login-form').addEventListener('submit', function(event) {
      event.preventDefault()

      const username = document.getElementById('username-field-login-form').value
      const password = document.getElementById('password-field-login-form').value

      // construir el objeto de datos a enviar
      const data = {
        username,
        password
      }

      // realizar la solicitud POST
      fetch('/api/v1/token/', {
        method: 'POST',
        headers: {
          'Content-Type': 'application/json'
        },
        body: JSON.stringify(data)
      })
      .then(response => {
        console.log(response, '---res')
        if (response.ok) {
          return response.json()
        } else {
          alert('Ocurrió un error al iniciar sesión.')
        }
      })
      .then(data => {
        const accessToken = data.access
        const refreshToken = data.refresh

        // guardar los tokens
        localStorage.setItem('accessToken', accessToken)
        localStorage.setItem('refreshToken', refreshToken)

        alert('Bienvenido!')
        location.reload()
      })
      .catch(error => {
        console.error('Error al enviar la solicitud:', error)
      })
    })

    // form refresh token
    document.getElementById('refresh-token-form').addEventListener('submit', function(event) {
      event.preventDefault()

      const refreshToken = localStorage.getItem('refreshToken')

      // realizar la solicitud POST
      fetch('/api/v1/token/refresh/', {
        method: 'POST',
        headers: {
          'Content-Type': 'application/json'
        },
        body: JSON.stringify({ refresh: refreshToken })
      })
      .then(response => {
        if (response.ok) {
          return response.json()
        } else {
          alert('Ocurrió un error al actualizar el refreshToken.')
        }
      })
      .then(data => {
        const accessToken = data.access

        // guardar el nuevo accessToken
        localStorage.setItem('accessToken', accessToken)

        alert('AccessToken actualizado!')
        location.reload()
      })
      .catch(error => {
        console.error('Error al enviar la solicitud:', error)
      })
    })

    // form delete tokens
    document.getElementById('delete-tokens-form').addEventListener('submit', function(event) {
      event.preventDefault()

      // eliminar los tokens
      localStorage.removeItem('accessToken')
      localStorage.removeItem('refreshToken')

      alert('Tokens eliminados!')
      location.reload()
    })

    // form signup-form
    document.getElementById('signup-form').addEventListener('submit', function(event) {
      event.preventDefault()

      const username = document.getElementById('username-field-signup-form').value
      const email = document.getElementById('email-field-signup-form').value
      const password = document.getElementById('password-field-signup-form').value

      // construir el objeto de datos a enviar
      const data = {
        username,
        email,
        password
      }

      // realizar la solicitud POST
      fetch('/signup/', {
        method: 'POST',
        headers: {
          'Content-Type': 'application/json'
        },
        body: JSON.stringify(data)
      })
      .then(response => {
        if (response.ok) {
          alert('Usuario creado exitosamente!')
          location.reload()
        } else {
          alert('Ocurrió un error al crear el usuario.')
        }
      })
      .catch(error => {
        console.error('Error al enviar la solicitud:', error)
      })
    })

    // form update-task-form
    document.getElementById('update-task-form').addEventListener('submit', function(event) {
      event.preventDefault()

      const id = document.getElementById('id-field-update-task-form').value
      const title = document.getElementById('title-field-update-task-form').value
      const description = document.getElementById('description-field-update-task-form').value

      // construir el objeto de datos a enviar
      const data = {
        title,
        description
      }

      // remover las propiedades que sean string vacios
      for (const key in data) {
        if (data[key] === '') {
          delete data[key]
        }
      }

      // realizar la solicitud PATCH
      fetch(`/api/v1/tasks/${id}/`, {
        method: 'PATCH',
        headers: {
          'Content-Type': 'application/json'
        },
        body: JSON.stringify(data)
      })
      .then(response => {
        if (response.ok) {
          alert('Tarea actualizada exitosamente!')
          location.reload()
        } else {
          alert('Ocurrió un error al actualizar la tarea.')
        }
      })
      .catch(error => {
        console.error('Error al enviar la solicitud:', error)
      })
    })

    // form delete-task-form
    document.getElementById('delete-task-form').addEventListener('submit', function(event) {
      event.preventDefault()

      const id = document.getElementById('id-field-delete-task-form').value

      // realizar la solicitud DELETE
      fetch(`/api/v1/tasks/${id}/`, {
        method: 'DELETE'
      })
      .then(response => {
        if (response.ok) {
          alert('Tarea eliminada exitosamente!')
          location.reload()
        } else {
          alert('Ocurrió un error al eliminar la tarea.')
        }
      })
      .catch(error => {
        console.error('Error al enviar la solicitud:', error)
      })
    })

    // form pagination-form
    document.getElementById('pagination-form').addEventListener('submit', function(event) {
      event.preventDefault()

      const page = document.getElementById('page-field-pagination-form').value
      const pageSize = document.getElementById('page-size-field-pagination-form').value

      const data = {
        page,
        size: pageSize
      }

      // remover las propiedades que sean string vacios
      for (const key in data) {
        if (data[key] === '') {
          delete data[key]
        }
      }

      // Función para convertir un objeto de parámetros en una cadena de consulta
      const objectToQueryParams = (obj) => {
        return Object.keys(obj).map(key => key + '=' + obj[key]).join('&')
      }

      let url = '/api/v1/tasks/'
      url += '?' + objectToQueryParams(data)

      // realizar la solicitud GET
      fetch(url, {
        method: 'GET',
        headers: {
          'Content-Type': 'application/json'
        },
        params: JSON.stringify(data)
      })
      .then(response => {
        if (response.ok) {
          return response.json()
        } else {
          alert('Ocurrió un error al obtener las tareas.')
        }
      })
      .then(data => {
        const tasks = data.results

        const summaryPagination = document.getElementById('summary-pagination')
        summaryPagination.textContent = `Total: ${data.count} | Previous: ${data.previous} | Next: ${data.next}`

        const tasksComponent = document.querySelector('ul')
        tasksComponent.innerHTML = 'id > titulo > email > user > descripcion > fecha expiracion'
        tasks.forEach(task => {
          const taskItem = document.createElement('li')
          taskItem.textContent = `${task.id} > ${task.title} > ${task.email} > ${task.user} > ${task.description} > ${task.date_expiration}`
          tasksComponent.appendChild(taskItem)
        })
      })
      .catch(error => {
        console.error('Error al enviar la solicitud:', error)
      })
    })

    // obtener las tareas del usuario autenticado
    if (accessToken) {
      _getMyTasks()
    }

    function _getMyTasks() {
      fetch('/api/v1/tasks/users/my/', {
        headers: {
          'Authorization': `Bearer ${accessToken}`
        }
      })
      .then(response => {
        if (response.ok) {
          return response.json()
        } else {
          if (response.status === 401) {
            alert('Tu accessToken ha expirado. Por favor, actualiza el refreshToken.')
            console.log(accessToken)
          } else {
            alert('Ocurrió un error al obtener tus tareas.')
          }
        }
      })
      .then(data => {
        const myTasks = data.results
        const myTasksComponent = document.getElementById('my-tasks')

        myTasksComponent.innerHTML = 'No hay tareas.'
        myTasks.forEach(task => {
          const taskItem = document.createElement('li')
          taskItem.textContent = `${task.id} > ${task.title} > ${task.email} > ${task.user} > ${task.description} > ${task.date_expiration}`
          myTasksComponent.appendChild(taskItem)
        })
      })
      .catch(error => {
        console.error('Error al enviar la solicitud:', error)
      })
    }
  </script>
</body>
</html>